// --------------------------------------------------------------------------------------------------------------
//
//   MPackMUI V1.0 GUI Module
//
// --------------------------------------------------------------------------------------------------------------

#include "GUI.h"

// --------------------------------------------------------------------------------------------------------------

void CreateGUI()
{
    APTR menustrip, menustrip2;

    // Create the GUI

    App = ApplicationObject,
        MUIA_Application_Title,         "MPackMUI",
        MUIA_Application_Version,       "$VER: MPackMUI V1.01",
        MUIA_Application_Copyright,     "No copyright",
        MUIA_Application_Author,        "ToneMaster, 2000",
        MUIA_Application_Description,   "MUI Interface for MPack V1.5",
        MUIA_Application_Base,          "ZZ02",

        // MAIN WINDOW

        SubWindow, Windows[WID_MAIN] = WindowObject,
            MUIA_Window_ID, MAKE_ID('X','X','0','1'),
            MUIA_Window_Menustrip, menustrip = MUI_MakeObject(MUIO_MenustripNM, MenuData, 0),
            MUIA_Window_Title, "MPackMUI V1.01",

            WindowContents, VGroup,
                Child, RegisterGroup(Labels),

                    // PAGE 1 - ENCODE

                    Child, VGroup,
                        Child, ColGroup(4), GroupFrame,

                            Child, Label2("Input File:"),
                            Child, Gadgets[GID_INPUT_STRING_P1] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_CycleChain, TRUE,
                            End,
                            Child, Gadgets[GID_INPUT_POP_P1] = PopButton(MUII_PopFile),
                            Child, HSpace(0),

                            Child, Label2("Output File:"),
                            Child, Gadgets[GID_OUTPUT_STRING_P1] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_CycleChain, TRUE,
                            End,
                            Child, Gadgets[GID_OUTPUT_POP_P1] = PopButton(MUII_PopFile),
                            Child, HSpace(0),

                            Child, Label2("Desc. File:"),
                            Child, Gadgets[GID_DESC_STRING_P1] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_CycleChain, TRUE,
                                MUIA_Disabled, TRUE,
                            End,
                            Child, Gadgets[GID_DESC_POP_P1] = PopButton(MUII_PopFile),

                            Child, Gadgets[GID_DESC_CHECK_P1] = CheckMark(FALSE),
                        End,

                        Child, VGroup, GroupFrame,

                            Child, Gadgets[GID_TYPE_GROUP_P1] = HGroup,

                                Child, Label2("Type:"),
                                Child, Gadgets[GID_TYPE_CYCLE_P1] = CycleObject,
                                    MUIA_Cycle_Entries, MIMETypes,
                                End,
                            End,

                            Child, HGroup,

                                Child, Label2("Subject:"),
                                Child, Gadgets[GID_SUBJECT_STRING_P1] = StringObject, StringFrame,
                                    MUIA_String_AdvanceOnCR, TRUE,
                                    MUIA_CycleChain, TRUE,
                                End,
                            End,

                            Child, ColGroup(3),

                                Child, Label2("Max. Size:"),
                                Child, Gadgets[GID_MAX_STRING_P1] = StringObject, StringFrame,
                                    MUIA_String_AdvanceOnCR, TRUE,
                                    MUIA_String_Accept, "0123456789",
                                    MUIA_String_Contents, "0",
                                    MUIA_String_MaxLen, 9,
                                    MUIA_CycleChain, TRUE,
                                    MUIA_Disabled, TRUE,
                                End,
                                Child, Gadgets[GID_MAX_CHECK_P1] = CheckMark(FALSE),
                            End,
                        End,

                        Child, VSpace(10),

                        Child, Gadgets[GID_PROGRESS_GAUGE_P1] = GaugeObject, GaugeFrame,
                            MUIA_Gauge_Current, 0,
                            MUIA_Gauge_Horiz, TRUE,
                            MUIA_Gauge_InfoText, "",
                            MUIA_Gauge_Max, 1,
                        End,

                        Child, Gadgets[GID_ENCODE_BUTTON_P1] = SimpleButton("Encode"),
                    End,

                    // PAGE 2 - DECODE

                    Child, VGroup,
                        Child, ColGroup(3), GroupFrame,

                            Child, Label2("Input File:"),
                            Child, Gadgets[GID_INPUT_STRING_P2] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_CycleChain, TRUE,
                            End,
                            Child, Gadgets[GID_INPUT_POP_P2] = PopButton(MUII_PopFile),

                            Child, Label2("Output Dir:"),
                            Child, Gadgets[GID_OUTPUT_STRING_P2] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_String_Contents, "RAM:",
                                MUIA_CycleChain, TRUE,
                            End,
                            Child, Gadgets[GID_OUTPUT_POP_P2] = PopButton(MUII_PopDrawer),
                        End,

                        Child, VSpace(10),

                        Child, ColGroup(3), GroupFrame,

                            Child, Label2("Force Overwrite"),
                            Child, Gadgets[GID_FORCE_CHECK_P2] = CheckMark(FALSE),
                            Child, HSpace(150),

                            Child, Label2("Unpack Text"),
                            Child, Gadgets[GID_UNPACK_CHECK_P2] = CheckMark(FALSE),
                            Child, HSpace(150),
                        End,

                        Child, VSpace(10),

                        Child, Gadgets[GID_PROGRESS_GAUGE_P2] = GaugeObject, GaugeFrame,
                            MUIA_Gauge_Current, 0,
                            MUIA_Gauge_Horiz, TRUE,
                            MUIA_Gauge_InfoText, "",
                            MUIA_Gauge_Max, 1,
                        End,

                        Child, Gadgets[GID_DECODE_BUTTON_P2] = SimpleButton("Decode"),
                    End,

                    // PAGE 3 - EMAIL

                    Child, VGroup,
                        Child, ColGroup(4), GroupFrame,

                            Child, Label2("Input File:"),
                            Child, Gadgets[GID_INPUT_STRING_P3] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_CycleChain, TRUE,
                            End,
                            Child, Gadgets[GID_INPUT_POP_P3] = PopButton(MUII_PopFile),
                            Child, HSpace(0),

                            Child, Label2("Address(es):"),
                            Child, Gadgets[GID_ADDRESS_STRING_P3] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_CycleChain, TRUE,
                            End,
                            Child, HSpace(0),
                            Child, HSpace(0),

                            Child, Label2("Desc. File:"),
                            Child, Gadgets[GID_DESC_STRING_P3] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_CycleChain, TRUE,
                                MUIA_Disabled, TRUE,
                            End,
                            Child, Gadgets[GID_DESC_POP_P3] = PopButton(MUII_PopFile),
                            Child, Gadgets[GID_DESC_CHECK_P3] = CheckMark(FALSE),
                        End,

                        Child, VGroup, GroupFrame,

                            Child, Gadgets[GID_TYPE_GROUP_P3] = HGroup,

                                Child, Label2("Type:"),
                                Child, Gadgets[GID_TYPE_CYCLE_P3] = CycleObject,
                                    MUIA_Cycle_Entries, MIMETypes,
                                End,
                            End,

                            Child, HGroup,

                                Child, Label2("Subject:"),
                                Child, Gadgets[GID_SUBJECT_STRING_P3] = StringObject, StringFrame,
                                    MUIA_String_AdvanceOnCR, TRUE,
                                    MUIA_CycleChain, TRUE,
                                End,
                            End,

                            Child, ColGroup(3),

                                Child, Label2("Max. Size:"),
                                Child, Gadgets[GID_MAX_STRING_P3] = StringObject, StringFrame,
                                    MUIA_String_AdvanceOnCR, TRUE,
                                    MUIA_String_Accept, "0123456789",
                                    MUIA_String_Contents, "0",
                                    MUIA_String_MaxLen, 9,
                                    MUIA_CycleChain, TRUE,
                                    MUIA_Disabled, TRUE,
                                End,
                                Child, Gadgets[GID_MAX_CHECK_P3] = CheckMark(FALSE),
                            End,
                        End,

                        Child, VSpace(10),

                        Child, Gadgets[GID_PROGRESS_GAUGE_P3] = GaugeObject, GaugeFrame,
                            MUIA_Gauge_Current, 0,
                            MUIA_Gauge_Horiz, TRUE,
                            MUIA_Gauge_InfoText, "",
                            MUIA_Gauge_Max, 1,
                        End,

                        Child, Gadgets[GID_ENCODE_BUTTON_P3] = SimpleButton("Encode & Send"),
                    End,

                    // PAGE 4 - NG

                    Child, VGroup,
                        Child, ColGroup(4), GroupFrame,

                            Child, Label2("Input File:"),
                            Child, Gadgets[GID_INPUT_STRING_P4] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_CycleChain, TRUE,
                            End,
                            Child, Gadgets[GID_INPUT_POP_P4] = PopButton(MUII_PopFile),
                            Child, HSpace(0),

                            Child, Label2("Newsgroup(s):"),
                            Child, Gadgets[GID_NEWSGROUP_STRING_P4] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_CycleChain, TRUE,
                            End,
                            Child, HSpace(0),
                            Child, HSpace(0),

                            Child, Label2("Desc. File:"),
                            Child, Gadgets[GID_DESC_STRING_P4] = StringObject, StringFrame,
                                MUIA_String_AdvanceOnCR, TRUE,
                                MUIA_CycleChain, TRUE,
                                MUIA_Disabled, TRUE,
                            End,
                            Child, Gadgets[GID_DESC_POP_P4] = PopButton(MUII_PopFile),
                            Child, Gadgets[GID_DESC_CHECK_P4] = CheckMark(FALSE),
                        End,

                        Child, VGroup, GroupFrame,

                            Child, Gadgets[GID_TYPE_GROUP_P4] = HGroup,

                                Child, Label2("Type:"),
                                Child, Gadgets[GID_TYPE_CYCLE_P4] = CycleObject,
                                    MUIA_Cycle_Entries, MIMETypes,
                                End,
                            End,

                            Child, HGroup,

                                Child, Label2("Subject:"),
                                Child, Gadgets[GID_SUBJECT_STRING_P4] = StringObject, StringFrame,
                                    MUIA_String_AdvanceOnCR, TRUE,
                                    MUIA_CycleChain, TRUE,
                                End,
                            End,

                            Child, ColGroup(3),

                                Child, Label2("Max. Size:"),
                                Child, Gadgets[GID_MAX_STRING_P4] = StringObject, StringFrame,
                                    MUIA_String_AdvanceOnCR, TRUE,
                                    MUIA_String_Accept, "0123456789",
                                    MUIA_String_Contents, "0",
                                    MUIA_String_MaxLen, 9,
                                    MUIA_CycleChain, TRUE,
                                    MUIA_Disabled, TRUE,
                                End,
                                Child, Gadgets[GID_MAX_CHECK_P4] = CheckMark(FALSE),
                            End,
                        End,

                        Child, VSpace(10),

                        Child, Gadgets[GID_PROGRESS_GAUGE_P4] = GaugeObject, GaugeFrame,
                            MUIA_Gauge_Current, 0,
                            MUIA_Gauge_Horiz, TRUE,
                            MUIA_Gauge_InfoText, "",
                            MUIA_Gauge_Max, 1,
                        End,

                        Child, Gadgets[GID_ENCODE_BUTTON_P4] = SimpleButton("Encode & Post"),
                    End,
                End,
            End,
        End,

        // MIME PREFS WINDOW

        SubWindow, Windows[WID_MIMEPREFS] = WindowObject,
            MUIA_Window_ID, MAKE_ID('X','X','0','2'),
            MUIA_Window_Menustrip, menustrip2 = MUI_MakeObject(MUIO_MenustripNM, Menu2Data, 0),
            MUIA_Window_Title, "MPackMUI V1.01 MIME Prefs",

            WindowContents, VGroup,

                Child, Gadgets[GID_MIMETYPES_LIST_PREFS] = ListviewObject,
                    MUIA_Listview_List, ListObject, ReadListFrame,
                        MUIA_List_SourceArray, MIMETypes,
                    End,
                End,

                Child, HGroup,
                    Child, Label2("MIME type:"),

                    Child, HGroup,
                        MUIA_Group_HorizSpacing, 0,

                        Child, Gadgets[GID_MIMETYPES_CYCLE_PREFS] = CycleObject,
                            MUIA_Cycle_Entries, PrefsCycleLabels,
                            MUIA_FixWidthTxt, "Application/",
                        End,

                        Child, Gadgets[GID_MIMETYPES_STRING_PREFS] = StringObject, StringFrame,
                        End,
                    End,
                End,

                Child, HGroup,
                    Child, Gadgets[GID_ADD_BUTTON_PREFS] = SimpleButton("Add"),
                    Child, Gadgets[GID_REMOVE_BUTTON_PREFS] = SimpleButton("Remove"),
                    Child, Gadgets[GID_COPY_BUTTON_PREFS] = SimpleButton("Copy"),
                    Child, Gadgets[GID_SORT_BUTTON_PREFS] = SimpleButton("Sort"),
                End,

                Child, RectangleObject, MUIA_Rectangle_HBar, TRUE, MUIA_FixHeight, 5, End,

                Child, HGroup,
                    Child, Gadgets[GID_SAVE_BUTTON_PREFS] = SimpleButton("Save"),
                    Child, Gadgets[GID_USE_BUTTON_PREFS] = SimpleButton("Use"),
                    Child, Gadgets[GID_CANCEL_BUTTON_PREFS] = SimpleButton("Cancel"),
                End,
            End,
        End,
    End;

    //Set initial enable/disable states

    set(Gadgets[GID_DESC_POP_P1], MUIA_Disabled, TRUE);
    set(Gadgets[GID_DESC_POP_P3], MUIA_Disabled, TRUE);
    set(Gadgets[GID_DESC_POP_P4], MUIA_Disabled, TRUE);

    // Find menu items

    Menus[MEN_ABOUT] =          (APTR)DoMethod(menustrip, MUIM_FindUData, MEN_ABOUT);
    Menus[MEN_ABOUTMUI] =       (APTR)DoMethod(menustrip, MUIM_FindUData, MEN_ABOUTMUI);
    Menus[MEN_QUIT] =           (APTR)DoMethod(menustrip, MUIM_FindUData, MEN_QUIT);
    Menus[MEN_MIMEPREFS] =      (APTR)DoMethod(menustrip, MUIM_FindUData, MEN_MIMEPREFS);
    Menus[MEN_MUIPREFS] =       (APTR)DoMethod(menustrip, MUIM_FindUData, MEN_MUIPREFS);
    Menus[MEN_RESET] =          (APTR)DoMethod(menustrip2, MUIM_FindUData, MEN_RESET);
    Menus[MEN_LASTSAVED] =      (APTR)DoMethod(menustrip2, MUIM_FindUData, MEN_LASTSAVED);
    Menus[MEN_RESTORE] =        (APTR)DoMethod(menustrip2, MUIM_FindUData, MEN_RESTORE);
    Menus[MEN_IMPORTAWEB] =     (APTR)DoMethod(menustrip2, MUIM_FindUData, MEN_IMPORTAWEB);
    Menus[MEN_IMPORTVOYAGER] =  (APTR)DoMethod(menustrip2, MUIM_FindUData, MEN_IMPORTVOYAGER);

    // Set up notifications

    DoMethod(Windows[WID_MAIN], MUIM_Notify, MUIA_Window_CloseRequest, TRUE, App, 2, MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);
    DoMethod(Windows[WID_MIMEPREFS], MUIM_Notify, MUIA_Window_CloseRequest, TRUE, Windows[WID_MIMEPREFS], 3, MUIM_CallHook, &PrefsCancelButtonHook, MUIV_TriggerValue);
    DoMethod(Menus[MEN_ABOUT], MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, Menus[MEN_ABOUT], 3, MUIM_CallHook, &MenuAboutHook, MUIV_TriggerValue);
    DoMethod(Menus[MEN_ABOUTMUI], MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, MUIV_Notify_Application, 2, MUIM_Application_AboutMUI, Windows[WID_MAIN]);
    DoMethod(Menus[MEN_QUIT], MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, App, 2, MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);
    DoMethod(Menus[MEN_MIMEPREFS], MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, Menus[MEN_MIMEPREFS], 3, MUIM_CallHook, &MenuMIMEPrefsHook, MUIV_TriggerValue);
    DoMethod(Menus[MEN_MUIPREFS], MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, MUIV_Notify_Application, 2, MUIM_Application_OpenConfigWindow, 0);
    DoMethod(Menus[MEN_RESET], MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, Menus[MEN_RESET], 3, MUIM_CallHook, &MenuResetPrefsHook, MUIV_TriggerValue);
    DoMethod(Menus[MEN_LASTSAVED], MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, Menus[MEN_LASTSAVED], 3, MUIM_CallHook, &MenuLastSavedPrefsHook, MUIV_TriggerValue);
    DoMethod(Menus[MEN_RESTORE], MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, Menus[MEN_RESTORE], 3, MUIM_CallHook, &MenuRestorePrefsHook, MUIV_TriggerValue);
    DoMethod(Menus[MEN_IMPORTAWEB], MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, Menus[MEN_IMPORTAWEB], 3, MUIM_CallHook, &MenuImportAwebPrefsHook, MUIV_TriggerValue);
    DoMethod(Menus[MEN_IMPORTVOYAGER], MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime, Menus[MEN_IMPORTVOYAGER], 3, MUIM_CallHook, &MenuImportVoyagerPrefsHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_INPUT_POP_P1], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_INPUT_POP_P1], 3, MUIM_CallHook, &Page1InputPopHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_OUTPUT_POP_P1], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_OUTPUT_POP_P1], 3, MUIM_CallHook, &Page1OutputPopHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_DESC_POP_P1], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_DESC_POP_P1], 3, MUIM_CallHook, &Page1DescPopHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_DESC_CHECK_P1], MUIM_Notify, MUIA_Pressed, MUIV_EveryTime, Gadgets[GID_DESC_CHECK_P1], 3, MUIM_CallHook, &Page1DescCheckHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_MAX_CHECK_P1], MUIM_Notify, MUIA_Pressed, MUIV_EveryTime, Gadgets[GID_MAX_CHECK_P1], 3, MUIM_CallHook, &Page1MaxCheckHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_ENCODE_BUTTON_P1], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_ENCODE_BUTTON_P1], 3, MUIM_CallHook, &Page1EncodeButtonHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_INPUT_POP_P2], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_INPUT_POP_P2], 3, MUIM_CallHook, &Page2InputPopHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_OUTPUT_POP_P2], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_OUTPUT_POP_P2], 3, MUIM_CallHook, &Page2OutputPopHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_DECODE_BUTTON_P2], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_DECODE_BUTTON_P2], 3, MUIM_CallHook, &Page2DecodeButtonHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_INPUT_POP_P3], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_INPUT_POP_P3], 3, MUIM_CallHook, &Page3InputPopHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_DESC_POP_P3], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_DESC_POP_P3], 3, MUIM_CallHook, &Page3DescPopHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_DESC_CHECK_P3], MUIM_Notify, MUIA_Pressed, MUIV_EveryTime, Gadgets[GID_DESC_CHECK_P3], 3, MUIM_CallHook, &Page3DescCheckHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_MAX_CHECK_P3], MUIM_Notify, MUIA_Pressed, MUIV_EveryTime, Gadgets[GID_MAX_CHECK_P3], 3, MUIM_CallHook, &Page3MaxCheckHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_ENCODE_BUTTON_P3], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_ENCODE_BUTTON_P3], 3, MUIM_CallHook, &Page3EncodeButtonHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_INPUT_POP_P4], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_INPUT_POP_P4], 3, MUIM_CallHook, &Page4InputPopHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_DESC_POP_P4], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_DESC_POP_P4], 3, MUIM_CallHook, &Page4DescPopHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_DESC_CHECK_P4], MUIM_Notify, MUIA_Pressed, MUIV_EveryTime, Gadgets[GID_DESC_CHECK_P4], 3, MUIM_CallHook, &Page4DescCheckHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_MAX_CHECK_P4], MUIM_Notify, MUIA_Pressed, MUIV_EveryTime, Gadgets[GID_MAX_CHECK_P4], 3, MUIM_CallHook, &Page4MaxCheckHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_ENCODE_BUTTON_P4], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_ENCODE_BUTTON_P4], 3, MUIM_CallHook, &Page4EncodeButtonHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_MIMETYPES_LIST_PREFS], MUIM_Notify, MUIA_List_Active, MUIV_EveryTime, Gadgets[GID_MIMETYPES_LIST_PREFS], 3, MUIM_CallHook, &PrefsMIMEListHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_MIMETYPES_CYCLE_PREFS], MUIM_Notify, MUIA_Cycle_Active, MUIV_EveryTime, Gadgets[GID_MIMETYPES_CYCLE_PREFS], 3, MUIM_CallHook, &PrefsMIMEUpdateHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_MIMETYPES_STRING_PREFS], MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime, Gadgets[GID_MIMETYPES_STRING_PREFS], 3, MUIM_CallHook, &PrefsMIMEUpdateHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_ADD_BUTTON_PREFS], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_ADD_BUTTON_PREFS], 3, MUIM_CallHook, &PrefsAddButtonHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_REMOVE_BUTTON_PREFS], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_REMOVE_BUTTON_PREFS], 3, MUIM_CallHook, &PrefsRemoveButtonHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_COPY_BUTTON_PREFS], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_COPY_BUTTON_PREFS], 3, MUIM_CallHook, &PrefsCopyButtonHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_SORT_BUTTON_PREFS], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_SORT_BUTTON_PREFS], 3, MUIM_CallHook, &PrefsSortButtonHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_SAVE_BUTTON_PREFS], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_SAVE_BUTTON_PREFS], 3, MUIM_CallHook, &PrefsSaveButtonHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_USE_BUTTON_PREFS], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_USE_BUTTON_PREFS], 3, MUIM_CallHook, &PrefsUseButtonHook, MUIV_TriggerValue);
    DoMethod(Gadgets[GID_CANCEL_BUTTON_PREFS], MUIM_Notify, MUIA_Pressed, FALSE, Gadgets[GID_CANCEL_BUTTON_PREFS], 3, MUIM_CallHook, &PrefsCancelButtonHook, MUIV_TriggerValue);

    // Check that application was created

    if (!(App))
    {
        DoEasyReq("Couldn't create application");
        CleanUp();
    } /* if */

    // Open the window

    set(Windows[WID_MAIN], MUIA_Window_Open, TRUE);
} /* CreateGUI() */

// --------------------------------------------------------------------------------------------------------------

// End Of Text
